<?php
/* Plugin Name: tigaman webdesign - Masonry Grid Gallery
 * Plugin URI: https://www.tigaman.com/
 * Description: This plugin allows you to create a responsive gallery with Masonry style layout in one click. No settings required!
 * Version: 1.0
 * Author: tigaman webdesign
 * Author URI: https://www.tigaman.hu
 */
function twdmgg_gallery_shortcode($attr) {
    $post = get_post();

    static $instance = 0;
    $instance++;

    if (!empty($attr['ids'])) {
        // Handle gallery by IDs
        $include = explode(',', $attr['ids']); // Split IDs by commas
    } elseif (!empty($attr['post_parent'])) {
        // Handle gallery by post_parent
        $include = get_children(array(
            'post_parent' => $post->ID,
            'post_status' => 'inherit',
            'post_type' => 'attachment',
            'post_mime_type' => 'image',
            'order' => 'ASC',
            'orderby' => 'menu_order ID',
        ));
        $include = array_keys($include);
    } else {
        // Handle regular gallery
        $include = wp_get_attachment_link($attr['include'], 'medium', true, false);
    }

    $output = "<div id='gallery-{$instance}' class='tigaman-masonry-grid-gallery'>";
    $i = 0;
    foreach ($include as $id) {
        $i++;
        $attachment = get_post($id);

        $image_url = wp_get_attachment_url($id);
        $image_link = wp_get_attachment_url($id);

        $caption = $attachment->post_excerpt;

        $medium_image_url = wp_get_attachment_image_src($id, 'medium'); // Get the medium-sized image URL
        $medium_image_url = $medium_image_url[0]; // Get the URL from the array

        $output .= "<div class='tigaman-masonry-grid-gallery-item'>";
        $output .= "<a href='$image_link' class='gallery-link' data-lightbox='gallery-{$instance}'>";
        $output .= "<img src='$medium_image_url' class='gallery-image' alt='$caption' />";
        $output .= "</a>";
		$output .= "<div class='tigaman-masonry-grid-gallery-mask'></div>";
        if ($caption) {
            $output .= "<div class='tigaman-masonry-grid-gallery-item-caption'>$caption</div>";
        }
        $output .= "</div>";
    }
    $output .= '</div>';

    return $output;
}

remove_shortcode('gallery');
add_shortcode('gallery', 'twdmgg_gallery_shortcode');


function twdmgg_enqueue_styles() {
    wp_enqueue_style('twdmgg-gallery-style', plugin_dir_url(__FILE__) . 'style.css');
}
add_action('wp_enqueue_scripts', 'twdmgg_enqueue_styles');


?>
